.\"	$NetBSD: isnormal.3,v 1.2 2004/01/15 20:30:46 wiz Exp $
.\"
.\" Copyright (c) 2003 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Klaus Klein.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd October 29, 2003
.Dt ISNORMAL 3
.Os
.Sh NAME
.Nm isnormal
.Nd test for normal value
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In math.h
.Ft int
.Fn isnormal "real-floating x"
.Sh DESCRIPTION
The
.Fn isnormal
macro determines whether its argument
.Fa x
has a normal value.
An argument represented in a format wider than its semantic type is
converted to its semantic type first.
The determination is then based on the type of the argument.
.Ss IEEE 754
It is determined whether the value of
.Fa x
is normal, and neither zero, subnormal, infinite nor NaN.
.Ss VAX
It is determined whether the value of
.Fa x
is finite, and neither true zero, dirty zero nor ROP.
.Sh RETURN VALUES
The
.Fn isnormal
macro returns a non-zero value if the value of
.Fa x
is finite.
Otherwise 0 is returned.
.Sh ERRORS
No errors are defined.
.Sh SEE ALSO
.Xr fpclassify 3 ,
.Xr isfinite 3 ,
.Xr math 3 ,
.Xr signbit 3
.Sh STANDARDS
The
.Fn isnormal
macro conforms to
.St -isoC-99 .
